<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.defaults.inc.php 0.13.1 2005/06/15 C K Wu

    class defaults {

//---- Defaults (Generic) Validation Checks

    function defaultsgen_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=exapi_lang("Error") ;
	
	if ($dt[company]=="")				$err=exapi_lang("Company Name Missing");
	if ($dt[contact]=="")				$err=exapi_lang("Company Contact Missing");
	if ($dt[phone] and !is_numeric($dt[phone]))	$err=exapi_lang("phone# must be numeric");
	if ($dt[fax] and !is_numeric($dt[fax]))		$err=exapi_lang("fax# must be numeric");
	if ($dt[email] and strpos($dt[email],'@')=='')	$err=exapi_lang("invalid email address");
	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		if ($result->fields('used_by')=="")
			$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=exapi_lang("Default Value Editting is being accessed by ").$result->fields('used_by');
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}
	
//---- Defaults (Ledger) Validation Checks

    function defaultslgr_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$db_type = $ckapi[hostsys][dbtype] ;
	$err=""; $error=exapi_lang("Error") ;
	
	if (strlen($dt[attrib1cap])>10)			$err=exapi_lang("Attribute1 caption descripton too long");
	if (substr_count($dt[attrib1cap]," ")>0)	$err=exapi_lang("Attribute1 caption should not contain space");
	if (strlen($dt[attrib2cap])>10)			$err=exapi_lang("Attribute2 caption description too long");
	if (substr_count($dt[attrib2cap]," ")>0)	$err=exapi_lang("Attribute2 caption should not contain space");
	if (strlen($dt[attrib3cap])>10)			$err=exapi_lang("Attribute3 caption description too long");
	if (substr_count($dt[attrib3cap]," ")>0)	$err=exapi_lang("Attribute3 caption should not contain space");
	$table = array(0,$dt[attrib1tbl], $dt[attrib2tbl], $dt[attrib3tbl]) ;
	$sdesc = array(0,$dt[attrib1sdesc],$dt[attrib2sdesc],$dt[attrib3sdesc]) ;
	$ldesc = array(0,$dt[attrib1ldesc],$dt[attrib2ldesc],$dt[attrib3ldesc]) ;
	for ($i=1; $i<4; $i++ ) {
		$tblid = $tblsdesc = $tblldesc = False ;
		$tbl = $table[$i] ;
		$sd  = $sdesc[$i] ;
		$ld  = $ldesc[$i] ;
		$sql = "select a.attname, format_type(a.atttypid,a.atttypmod) from pg_class c,pg_attribute a " ;
		$sql.= "where c.relname='$tbl' and a.attnum>0 and a.attrelid=c.oid" ;
		if ($db_type=="mysql")		$sql = "describe $tbl" ;
		$result = $adodb->query($sql);
		While ($rs=$result->fetchRow()) {
			$fldname = $rs[0] ;
			$fldtype = $rs[1] ;
			if ($fldname=="id" and substr($fldtype,0,3)=='int')	$tblid = True ;
			if ($fldname==$sd) 					$tblsdesc = True ;
			if ($fldname==$ld)					$tblldesc = True ;
			}
		$attablei = "[".exapi_lang("Attrib table")." $i]" ;
		if (!$tblid)	$err=$attablei.exapi_lang("must have id field [type int(eger)]");
		if (!$tblsdesc)	$err=$attablei.exapi_lang("does not have field ")."[$sd]" ;
		if (!$tblldesc)	$err=$attablei.exapi_lang("does not have field ")."[$ld]" ;
		}
	if (input2date($dt[yearend])=="")		$err=exapi_lang("Invalid Year End Date");
	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		if ($result->fields('used_by')=="")
			$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=exapi_lang("Default Value Editting is being accessed by ").$result->fields('used_by');
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}
	
//---- Defaults (AP/AR/PO/SO/Quotation) Validation Checks

    function defaultsapr_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=exapi_lang("Error") ;

	if (strlen($dt[aptax1cap])>10)			$err=exapi_lang("AP/PO Primary Tax caption descripton too long");
	if (substr_count($dt[aptax1cap]," ")>0)		$err=exapi_lang("AP/PO Primary Tax caption should not contain space");
	if (strlen($dt[aptax2cap])>10)			$err=exapi_lang("AP/PO Secondary Tax caption descripton too long");
	if (substr_count($dt[aptax2cap]," ")>0)		$err=exapi_lang("AP/PO Secondary Tax caption should not contain space");
	if (strlen($dt[artax1cap])>10)			$err=exapi_lang("AR/SO/Quotation Primary Tax caption descripton too long");
	if (substr_count($dt[artax1cap]," ")>0)		$err=exapi_lang("AR/SO/Quotation Primary Tax caption should not contain space");
	if (strlen($dt[artax2cap])>10)			$err=exapi_lang("AR/SO/Quotation Secondary Tax caption descripton too long");
	if (substr_count($dt[artax2cap]," ")>0)		$err=exapi_lang("AR/SO/Quotation Secondary Tax caption should not contain space");
	if ($dt[paypalemail] and strpos($dt[paypalemail],'@')=='')	$err=exapi_lang("invalid Paypal email address");
	if ($dt[paypalyn]=='yes' and $dt[paypalemail]=='')		$err=exapi_lang("Paypal email address missing");
	if ($dt[paymateyn]=='yes' and $dt[paymateuname]=='')		$err=exapi_lang("PayMate Login User Name missing");

	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		if ($result->fields('used_by')=="")
			$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=exapi_lang("Default Value Editting is being accessed by ").$result->fields('used_by');
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Defaults (Point of Sale) Validation Checks

    function defaultspos_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=exapi_lang("Error") ;

	if (strlen($dt[postax1cap])>10)			$err=exapi_lang("POS Primary Tax caption descripton too long");
	if (substr_count($dt[postax1cap]," ")>0)	$err=exapi_lang("POS Primary Tax caption should not contain space");
	if (strlen($dt[postax2cap])>10)			$err=exapi_lang("POS Secondary Tax caption descripton too long");
	if (substr_count($dt[postax2cap]," ")>0)	$err=exapi_lang("POS Secondary Tax caption should not contain space");
	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		if ($result->fields('used_by')=="")
			$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=exapi_lang("Default Value Editting is being accessed by ").$result->fields('used_by');
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Defaults (HR/SSS/Payroll) Validation Checks

    function defaultshrp_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=exapi_lang("Error") ;

	if ($dt[mndfactor]=="")				$err=exapi_lang("Daily Salary Imputation (monthly) divisor Missing");
	if ($dt[smdfactor]=="")				$err=exapi_lang("Daily Salary Imputation (semi-monthly) divisor Missing");
	if ($dt[wkdfactor]=="")				$err=exapi_lang("Daily Salary Imputation (weekly) divisor Missing");
	if ($dt[mnhfactor]=="")				$err=exapi_lang("Hourly Salary Imputation (monthly) divisor Missing");
	if ($dt[smhfactor]=="")				$err=exapi_lang("Hourly Salary Imputation (semi-monthly) divisor Missing");
	if ($dt[wkhfactor]=="")				$err=exapi_lang("Hourly Salary Imputation (weekly) divisor Missing");
	if ($dt[dyhfactor]=="")				$err=exapi_lang("Hourly Salary Imputation (daily) divisor Missing");
	if (!is_numeric($dt[mndfactor]) or strpos($dt[mndfactor],".")<>"")
							$err=exapi_lang("Daily Salary Imputation (monthly) divisor must be integer");
	if (!is_numeric($dt[smdfactor]) or strpos($dt[smdfactor],".")<>"")
							$err=exapi_lang("Daily Salary Imputation (semi-monthly) divisor must be integer");
	if (!is_numeric($dt[wkdfactor]))		$err=exapi_lang("Daily Salary Imputation (weekly) divisor must be numeric");
	if (!is_numeric($dt[mnhfactor]) or strpos($dt[mnhfactor],".")<>"")
							$err=exapi_lang("Hourly Salary Imputation (monthly) divisor must be integer");
	if (!is_numeric($dt[smhfactor]) or strpos($dt[smhfactor],".")<>"")
							$err=exapi_lang("Hourly Salary Imputation (semi-monthly) divisor must be integer");
	if (!is_numeric($dt[wkhfactor]) or strpos($dt[wkhfactor],".")<>"")
							$err=exapi_lang("Hourly Salary Imputation (weekly) divisor must be integer");
	if (!is_numeric($dt[dyhfactor]) or strpos($dt[dyhfactor],".")<>"")
							$err=exapi_lang("Hourly Salary Imputation (daily) divisor must be integer");
	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		if ($result->fields('used_by')=="")
			$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=exapi_lang("Default Value Editting is being accessed by ").$result->fields('used_by');
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Defaults (CSS) Validation Checks

    function defaultscss_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=exapi_lang("Error") ;

	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		if ($result->fields('used_by')=="")
			$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=exapi_lang("Default Value Editting is being accessed by ").$result->fields('used_by');
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Defaults (Generic) Detail

    function defaultsgen_write() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_company',exapi_lang('Company Name'));
	$t->set_var('lang_logo',exapi_lang('Logo'));
	$t->set_var('lang_editlogo',exapi_lang('Click here to edit Logo'));
	$t->set_var('lang_address',exapi_lang('Address'));
	$t->set_var('lang_contact',exapi_lang('Contact'));
	$t->set_var('lang_phone',exapi_lang('Phone'));
	$t->set_var('lang_fax',exapi_lang('Fax'));
	$t->set_var('lang_email',exapi_lang('E-Mail'));
	$t->set_var('lang_weightunit',exapi_lang('Unit Weight'));
	$t->set_var('lang_version',exapi_lang('Software Version'));
	$t->set_var('lang_readonlygrp',exapi_lang('Read Only User Group'));
	$t->set_var('lang_rog',exapi_lang('can only access [Report]'));

	$t->set_var('id',$dt[id]);
	$t->set_var('company',$dt[company]);
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('editlogo',exapi_link("/$app/logoedit.php","id=$dt[id]"));
	$t->set_var('addr1',$dt[addr1]);
	$t->set_var('addr2',$dt[addr2]);
	$t->set_var('addr3',$dt[addr3]);
	$t->set_var('addr4',$dt[addr4]);
	$t->set_var('readonlygrp',$dt[readonlygrp]);
	$t->set_var('contact',$dt[contact]);
	$t->set_var('phone',$dt[phone]);
	$t->set_var('fax',$dt[fax]);
	$t->set_var('email',$dt[email]);
	$t->set_var('nativecurr',$dt[nativecurr]);
	$t->set_var('weightunit',$dt[weightunit]);
	$t->set_var('yearend',$dt[yearend]);
	$t->set_var('version',$dt[version]);

	$img = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$t->set_var('image',exapi_link("/$app/logoview_image.php","imgfile=$img"));

	$t->parse('out','report',True);
	}
	
//---- Write Defaults (Ledger) Detail

    function defaultslgr_write() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$yes=exapi_lang('Yes'); $no=exapi_lang('No'); 
	$yesno_sl = "<OPTION value='yes'>$yes</option><OPTION value='no'>$no</option>" ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;

	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_attribdef',exapi_lang('Attribute'));
	$t->set_var('lang_attribcap',exapi_lang('Caption<br>Description'));
	$t->set_var('lang_attribtbl',exapi_lang('Table Name'));
	$t->set_var('lang_attribsdesc',exapi_lang('Short Desc Field Name'));
	$t->set_var('lang_attribldesc',exapi_lang('Long Desc Field Name'));
	$t->set_var('lang_attribtblmn',exapi_lang('Allow Table Maintenance<br>in Ledger module'));
	$t->set_var('lang_attribcnval',exapi_lang('Keep Value Constant<br>within a single journal'));
	$t->set_var('lang_attrib1',exapi_lang('Attribute1'));
	$t->set_var('lang_attrib2',exapi_lang('Attribute2'));
	$t->set_var('lang_attrib3',exapi_lang('Attribute3'));
	
	$t->set_var('lang_nativecurr',exapi_lang('Ledger Currency'));
	$t->set_var('lang_yearend',exapi_lang('Year End Date'));
	$t->set_var('lang_inc',exapi_lang('Income A/C'));
	$t->set_var('lang_exp',exapi_lang('Expense A/C'));
	$t->set_var('lang_inv',exapi_lang('Inventory A/C'));

	$t->set_var('id',$dt[id]);
	$t->set_var('attrib1cap',$dt[attrib1cap]);
	$t->set_var('attrib2cap',$dt[attrib2cap]);
	$t->set_var('attrib3cap',$dt[attrib3cap]);
	$t->set_var('attrib1tbl_selectlist',$this->table_selectlist("",$dt[attrib1tbl]));
	$t->set_var('attrib2tbl_selectlist',$this->table_selectlist("",$dt[attrib2tbl]));
	$t->set_var('attrib3tbl_selectlist',$this->table_selectlist("",$dt[attrib3tbl]));
	$t->set_var('attrib1sdesc',$dt[attrib1sdesc]);
	$t->set_var('attrib2sdesc',$dt[attrib2sdesc]);
	$t->set_var('attrib3sdesc',$dt[attrib3sdesc]);
	$t->set_var('attrib1ldesc',$dt[attrib1ldesc]);
	$t->set_var('attrib2ldesc',$dt[attrib2ldesc]);
	$t->set_var('attrib3ldesc',$dt[attrib3ldesc]);
	$tblmn_sl = str_replace("'$dt[attrib1tblmn]'","'$dt[attrib1tblmn]'"." selected",$yesno_sl) ;
	$t->set_var('attrib1tblmn_selectlist',$tblmn_sl);
	$tblmn_sl = str_replace("'$dt[attrib2tblmn]'","'$dt[attrib2tblmn]'"." selected",$yesno_sl) ;
	$t->set_var('attrib2tblmn_selectlist',$tblmn_sl);
	$tblmn_sl = str_replace("'$dt[attrib3tblmn]'","'$dt[attrib3tblmn]'"." selected",$yesno_sl) ;
	$t->set_var('attrib3tblmn_selectlist',$tblmn_sl);
	$cnval_sl = str_replace("'$dt[attrib1cnval]'","'$dt[attrib1cnval]'"." selected",$yesno_sl) ;
	$t->set_var('attrib1cnval_selectlist',$cnval_sl);
	$cnval_sl = str_replace("'$dt[attrib2cnval]'","'$dt[attrib2cnval]'"." selected",$yesno_sl) ;
	$t->set_var('attrib2cnval_selectlist',$cnval_sl);
	$cnval_sl = str_replace("'$dt[attrib3cnval]'","'$dt[attrib3cnval]'"." selected",$yesno_sl) ;
	$t->set_var('attrib3cnval_selectlist',$cnval_sl);

	$t->set_var('nativecurr_selectlist',selectlist('currency','isocode','',$dt[nativecurr],'isocode','isocode','description'));
	$t->set_var('yearend',$dt[yearend]);
	$t->set_var('inc_selectlist',selectlist('chart','accno',"WHERE link like '%AR_amount%'",$dt[income_accno_id],'id','accno','description','id'));
	$t->set_var('exp_selectlist',selectlist('chart','accno',"WHERE link like '%AP_amount%'",$dt[expense_accno_id],'id','accno','description','id'));
	$t->set_var('inv_selectlist',selectlist('chart','accno',"WHERE link like '%IC:%' or link like '%IC'",$dt[inventory_accno_id],'id','accno','description','id'));

	$t->parse('out','report',True);
	}
	
//---- Write Defaults (AP/AR/PO/SO/Quotation) Detail

    function defaultsapr_write() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$irate = exapi_lang('apply item tax rate') ;
	$crate = exapi_lang('apply customer rate') ;
	$vrate = exapi_lang('apply vendor rate') ;
	$srate = exapi_lang('apply my std rate') ;
	$zrate = exapi_lang('tax rate = zero') ;
	$mrate = exapi_lang('manual tax input') ;
	$aptax_pref_slist = "<OPTION value=''></OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='i'>$irate</OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='v'>$vrate</OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='s'>$srate</OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='z'>$zrate</OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='m'>$mrate</OPTION>" ;
	$artax_pref_slist = "<OPTION value=''></OPTION>" ;
	$artax_pref_slist.= "<OPTION value='i'>$irate</OPTION>" ;
	$artax_pref_slist.= "<OPTION value='c'>$crate</OPTION>" ;
	$artax_pref_slist.= "<OPTION value='s'>$srate</OPTION>" ;
	$artax_pref_slist.= "<OPTION value='z'>$zrate</OPTION>" ;
	$artax_pref_slist.= "<OPTION value='m'>$mrate</OPTION>" ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;

	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_aptax',exapi_lang('AP/PO Tax'));
	$t->set_var('lang_aptax1',exapi_lang('Primary'));
	$t->set_var('lang_aptax2',exapi_lang('Secondary'));
	$t->set_var('lang_aptaxcap',exapi_lang('Caption Description'));
	$langits = exapi_lang('Initial Setting of Tax Rate Drop Down Select List') ;
	$note = exapi_lang('(my std rate = my standard rate as a customer)') ;
	$t->set_var('lang_aptaxpref',"$langits:  $note");
	$t->set_var('lang_artax',exapi_lang('AR/SO/Quotation Tax'));
	$t->set_var('lang_artax1',exapi_lang('Primary'));
	$t->set_var('lang_artax2',exapi_lang('Secondary'));
	$t->set_var('lang_artaxcap',exapi_lang('Caption Description'));
	$note = exapi_lang('(my std rate = my standard rate as a vendor)') ;
	$t->set_var('lang_artaxpref',"$langits:  $note");
	$t->set_var('lang_offinvoice',exapi_lang('Formatting of Official Customer Invoice'));
	$t->set_var('lang_paypal',exapi_lang('Paypal'));
	$t->set_var('lang_paymate',exapi_lang('Paymate'));
	$t->set_var('lang_payasia',exapi_lang('PaymentAsia'));
	$t->set_var('lang_button',exapi_lang('Generate click button to direct customer to payment gateway'));
	$t->set_var('lang_paypalemail',exapi_lang('Paypal Email Address'));
	$t->set_var('lang_paymateuname',exapi_lang('Paymate Login User Name'));

	$t->set_var('lang_remark',exapi_lang('Remarks'));
	$t->set_var('lang_invoice',exapi_lang('Invoice'));
	$t->set_var('lang_reminder',exapi_lang('Reminder'));
	$t->set_var('lang_po',exapi_lang('PO'));
	$t->set_var('lang_quo',exapi_lang('Quotation'));

	$yes=exapi_lang('Yes'); $no=exapi_lang('No'); 
	$yesno_sl = "<OPTION value='yes'>$yes</option><OPTION value='no'>$no</option>" ;
	$t->set_var('id',$dt[id]);
	$t->set_var('aptax1cap',$dt[aptax1cap]);
	$t->set_var('aptax2cap',$dt[aptax2cap]);
	$tax1_sl = str_replace("'$dt[aptax1pref]'","'$dt[aptax1pref]'"." selected",$aptax_pref_slist) ;
	$t->set_var('aptax1pref_selectlist',$tax1_sl);
	$tax2_sl = str_replace("'$dt[aptax2pref]'","'$dt[aptax2pref]'"." selected",$aptax_pref_slist) ;
	$t->set_var('aptax2pref_selectlist',$tax2_sl);
	$t->set_var('artax1cap',$dt[artax1cap]);
	$t->set_var('artax2cap',$dt[artax2cap]);
	$tax1_sl = str_replace("'$dt[artax1pref]'","'$dt[artax1pref]'"." selected",$artax_pref_slist) ;
	$t->set_var('artax1pref_selectlist',$tax1_sl);
	$tax2_sl = str_replace("'$dt[artax2pref]'","'$dt[artax2pref]'"." selected",$artax_pref_slist) ;
	$t->set_var('artax2pref_selectlist',$tax2_sl);
	$paypalyn_sl = str_replace("'$dt[paypalyn]'","'$dt[paypalyn]'"." selected",$yesno_sl) ;
	$t->set_var('paypalyn_selectlist',$paypalyn_sl);
	$paymateyn_sl = str_replace("'$dt[paymateyn]'","'$dt[paymateyn]'"." selected",$yesno_sl) ;
	$t->set_var('paymateyn_selectlist',$paymateyn_sl);
	$payasiayn_sl = str_replace("'$dt[payasiayn]'","'$dt[payasiayn]'"." selected",$yesno_sl) ;
	$t->set_var('payasiayn_selectlist',$payasiayn_sl);
	$t->set_var('paypalemail',$dt[paypalemail]);
	$t->set_var('paymateuname',$dt[paymateuname]);
	$t->set_var('invrmk_selectlist',selectlist('remark','name','',$dt[inv_rmkid],'id','name','substring(description,1,60)','id'));
	$t->set_var('rmdrmk_selectlist',selectlist('remark','name','',$dt[rmd_rmkid],'id','name','substring(description,1,60)','id'));
	$t->set_var('pormk_selectlist',selectlist('remark','name','',$dt[po_rmkid],'id','name','substring(description,1,60)','id'));
	$t->set_var('quormk_selectlist',selectlist('remark','name','',$dt[quo_rmkid],'id','name','substring(description,1,60)','id'));

	$t->parse('out','report',True);
	}
	
//---- Write Defaults (Point of Sale) Detail

    function defaultspos_write() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$irate = exapi_lang('apply item tax rate') ;
	$srate = exapi_lang('apply my std rate') ;
	$postax_pref_slist = "<OPTION value='i'>$irate</OPTION>" ;
	$postax_pref_slist.= "<OPTION value='s'>$srate</OPTION>" ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;

	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_postax',exapi_lang('POS Tax'));
	$t->set_var('lang_postax1',exapi_lang('Primary'));
	$t->set_var('lang_postax2',exapi_lang('Secondary'));
	$t->set_var('lang_postaxcap',exapi_lang('Caption Description'));
	$langtx = exapi_lang('What Type of Tax Rate to apply to Cash Sale') ;
	$note = exapi_lang('(my std rate = my standard rate as a vendor)') ;
	$t->set_var('lang_postaxpref',"$langtx:  $note");
	$t->set_var('lang_remark',exapi_lang('Remarks'));
	$t->set_var('lang_sm',exapi_lang('Sales Memo'));

	$t->set_var('id',$dt[id]);
	$t->set_var('postax1cap',$dt[postax1cap]);
	$t->set_var('postax2cap',$dt[postax2cap]);
	$tax1_sl = str_replace("'$dt[postax1pref]'","'$dt[postax1pref]'"." selected",$postax_pref_slist) ;
	$t->set_var('postax1pref_selectlist',$tax1_sl);
	$tax2_sl = str_replace("'$dt[postax2pref]'","'$dt[postax2pref]'"." selected",$postax_pref_slist) ;
	$t->set_var('postax2pref_selectlist',$tax2_sl);
	$t->set_var('smrmk_selectlist',selectlist('remark','name','',$dt[sm_rmkid],'id','name','substring(description,1,60)','id'));
	
	$t->parse('out','report',True);
	}

//---- Write Defaults (PHR/SSS/Payroll) Detail

    function defaultshrp_write() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$yes=exapi_lang('Yes'); $no=exapi_lang('No'); 
	$yesno_sl = "<OPTION value='yes'>$yes</option><OPTION value='no'>$no</option>" ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;

	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_hr',exapi_lang('Human Resources'));
	$t->set_var('lang_photo',exapi_lang('Photo'));
	$t->set_var('lang_comm',exapi_lang('Communication Data'));
	$t->set_var('lang_address',exapi_lang('Address'));
	$t->set_var('lang_ec',exapi_lang('Emergency Contact'));
	$t->set_var('lang_others',exapi_lang('Others'));
	$t->set_var('lang_update',exapi_lang('Staff allowed to update their personal info regarding this data ?'));

	$t->set_var('lang_pyr',exapi_lang('Payroll'));
	$t->set_var('lang_mn',exapi_lang('Monthly'));
	$t->set_var('lang_smn',exapi_lang('Semi-monthly'));
	$t->set_var('lang_wk',exapi_lang('Weekly'));
	$t->set_var('lang_dy',exapi_lang('Daily'));
	$t->set_var('lang_salary',exapi_lang('Salary divided by'));
	$t->set_var('lang_daypay',exapi_lang('Imputed Daily Salary calculated by:'));
	$t->set_var('lang_hourpay',exapi_lang('Imputed Hourly Salary calculated by:'));

	$t->set_var('id',$dt[id]);
	$photoyn_sl = str_replace("'$dt[photoyn]'","'$dt[photoyn]'"." selected",$yesno_sl) ;
	$t->set_var('photoyn_selectlist',$photoyn_sl);
	$commyn_sl = str_replace("'$dt[commyn]'","'$dt[commyn]'"." selected",$yesno_sl) ;
	$t->set_var('commyn_selectlist',$commyn_sl);
	$addressyn_sl = str_replace("'$dt[addressyn]'","'$dt[addressyn]'"." selected",$yesno_sl) ;
	$t->set_var('addressyn_selectlist',$addressyn_sl);
	$ecyn_sl = str_replace("'$dt[ecyn]'","'$dt[ecyn]'"." selected",$yesno_sl) ;
	$t->set_var('ecyn_selectlist',$ecyn_sl);
	$othersyn_sl = str_replace("'$dt[othersyn]'","'$dt[othersyn]'"." selected",$yesno_sl) ;
	$t->set_var('othersyn_selectlist',$othersyn_sl);

	$t->set_var('mndfactor',$dt[mndfactor]);
	$t->set_var('smdfactor',$dt[smdfactor]);
	$t->set_var('wkdfactor',$dt[wkdfactor]);
	$t->set_var('mnhfactor',$dt[mnhfactor]);
	$t->set_var('smhfactor',$dt[smhfactor]);
	$t->set_var('wkhfactor',$dt[wkhfactor]);
	$t->set_var('dyhfactor',$dt[dyhfactor]);

	$t->parse('out','report',True);
	}

//---- Write Defaults (CSS) Detail

    function defaultscss_write() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$yes=exapi_lang('Yes'); $no=exapi_lang('No'); 
	$yesno_sl = "<OPTION value='yes'>$yes</option><OPTION value='no'>$no</option>" ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;

	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_css',exapi_lang('Customer Self Service Header Menu'));
	$t->set_var('lang_center',exapi_lang('Customer Service Center'));
	$t->set_var('lang_contactus',exapi_lang('Contact us'));
	$t->set_var('lang_ledreport',exapi_lang('Ledger Reports'));
	$t->set_var('lang_visible',exapi_lang('Header menu visible to customer ?'));

	$t->set_var('lang_centerlink',exapi_lang('Customer Service Center Items'));
	$t->set_var('lang_linkvisible',exapi_lang('Item link visible to customer ?'));
	$t->set_var('lang_custinfo',exapi_lang('Customer Info'));
	$t->set_var('lang_cttinfo',exapi_lang('Contact Detail'));
	$t->set_var('lang_helpcase',exapi_lang('Helpdesk Contact Case'));
	$t->set_var('lang_contract',exapi_lang('Contract'));
	$t->set_var('lang_quote',exapi_lang('Quotation'));
	$t->set_var('lang_so',exapi_lang('Sales Order'));
	$t->set_var('lang_invoice',exapi_lang('Invoice'));
	$t->set_var('lang_ubso',exapi_lang('Unbilled Sales Order'));
	$t->set_var('lang_osinv',exapi_lang('Outstanding Invoice'));
	$t->set_var('lang_statement',exapi_lang('Statement'));

	$t->set_var('id',$dt[id]);
	$centeryn_sl = str_replace("'$dt[centeryn]'","'$dt[centeryn]'"." selected",$yesno_sl) ;
	$t->set_var('centeryn_selectlist',$centeryn_sl);
	$contactusyn_sl = str_replace("'$dt[contactusyn]'","'$dt[contactusyn]'"." selected",$yesno_sl) ;
	$t->set_var('contactusyn_selectlist',$contactusyn_sl);
	$ledreportyn_sl = str_replace("'$dt[ledreportyn]'","'$dt[ledreportyn]'"." selected",$yesno_sl) ;
	$t->set_var('ledreportyn_selectlist',$ledreportyn_sl);
	$custinfoyn_sl = str_replace("'$dt[custinfoyn]'","'$dt[custinfoyn]'"." selected",$yesno_sl) ;
	$t->set_var('custinfoyn_selectlist',$custinfoyn_sl);
	$cttinfoyn_sl = str_replace("'$dt[cttinfoyn]'","'$dt[cttinfoyn]'"." selected",$yesno_sl) ;
	$t->set_var('cttinfoyn_selectlist',$cttinfoyn_sl);
	$helpcaseyn_sl = str_replace("'$dt[helpcaseyn]'","'$dt[helpcaseyn]'"." selected",$yesno_sl) ;
	$t->set_var('helpcaseyn_selectlist',$helpcaseyn_sl);
	$contractyn_sl = str_replace("'$dt[contractyn]'","'$dt[contractyn]'"." selected",$yesno_sl) ;
	$t->set_var('contractyn_selectlist',$contractyn_sl);
	$quoteyn_sl = str_replace("'$dt[quoteyn]'","'$dt[quoteyn]'"." selected",$yesno_sl) ;
	$t->set_var('quoteyn_selectlist',$quoteyn_sl);
	$soyn_sl = str_replace("'$dt[soyn]'","'$dt[soyn]'"." selected",$yesno_sl) ;
	$t->set_var('soyn_selectlist',$soyn_sl);
	$invoiceyn_sl = str_replace("'$dt[invoiceyn]'","'$dt[invoiceyn]'"." selected",$yesno_sl) ;
	$t->set_var('invoiceyn_selectlist',$invoiceyn_sl);
	$ubsoyn_sl = str_replace("'$dt[ubsoyn]'","'$dt[ubsoyn]'"." selected",$yesno_sl) ;
	$t->set_var('ubsoyn_selectlist',$ubsoyn_sl);
	$osinvyn_sl = str_replace("'$dt[osinvyn]'","'$dt[osinvyn]'"." selected",$yesno_sl) ;
	$t->set_var('osinvyn_selectlist',$osinvyn_sl);
	$statementyn_sl = str_replace("'$dt[statementyn]'","'$dt[statementyn]'"." selected",$yesno_sl) ;
	$t->set_var('statementyn_selectlist',$statementyn_sl);

	$t->parse('out','report',True);
	}

//---- Default Value Post (posting data to db table)

    function post() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	$tranobj = &$ckapi[objects][tranobj] ;

	$db_type = $ckapi[hostsys][dbtype] ;
	$table = "${pre}defaults";
	$id = ($dt[id]=="") ? 0 : $dt[id] ;
	$ip = ($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'] ;
	$user = $ckapi[hostsys][username];
	$now = mktime() ;
	$iptime = "$ip=$now=$script=$id" ;

	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$adodb->query($sql);
	$sql = "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
	$sql.= "VALUES ('$id','$app','$script','$ip','$user','$op','$now','$iptime')" ;
	$adodb->query($sql);
	$result = $adodb->query("SELECT id from ${pre}log WHERE iptime='$iptime'");
	$logid = $result->fields('id');

	switch ($tran) :
		case "defaultsgen" :
			$sql = "UPDATE $table SET company='$dt[company]',addr1='$dt[addr1]',addr2='$dt[addr2]'," ;
			$sql.= "addr3='$dt[addr3]',addr4='$dt[addr4]',contact='$dt[contact]',phone='$dt[phone]',";
			$sql.= "email='$dt[email]',fax='$dt[fax]',weightunit='$dt[weightunit]'," ;
			$sql.= "version='$dt[version]',readonlygrp='$dt[readonlygrp]' ";
			$adodb->query($sql);
			$sql = "SELECT id,company,addr1,addr2,addr3,addr4,contact,phone,email,fax,weightunit,version,readonlygrp FROM $table ";
			$result = $adodb->query($sql);
			$headerarr[$table] = $result->fetchRow();
			$header = addslashes(serialize($headerarr));
			$adodb->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = exapi_lang("Old") ;
			$lang_tran = exapi_lang("Generic Default Values") ;
			$actioned = exapi_lang("updated") ;
			break ;
		case "defaultslgr" :
			$sql = "UPDATE $table SET " ;
			$sql.= "attrib1cap='$dt[attrib1cap]',attrib2cap='$dt[attrib2cap]',attrib3cap='$dt[attrib3cap]',";
			$sql.= "attrib1tbl='$dt[attrib1tbl]',attrib2tbl='$dt[attrib2tbl]',attrib3tbl='$dt[attrib3tbl]',";
			$sql.= "attrib1sdesc='$dt[attrib1sdesc]',attrib2sdesc='$dt[attrib2sdesc]',attrib3sdesc='$dt[attrib3sdesc]',";
			$sql.= "attrib1ldesc='$dt[attrib1ldesc]',attrib2ldesc='$dt[attrib2ldesc]',attrib3ldesc='$dt[attrib3ldesc]',";
			$sql.= "attrib1tblmn='$dt[attrib1tblmn]',attrib2tblmn='$dt[attrib2tblmn]',attrib3tblmn='$dt[attrib3tblmn]',";
			$sql.= "attrib1cnval='$dt[attrib1cnval]',attrib2cnval='$dt[attrib2cnval]',attrib3cnval='$dt[attrib3cnval]',";
			$sql.= "nativecurr='$dt[nativecurr]',yearend='$dt[yearend]',income_accno_id='$dt[income_accno_id]'," ;
			$sql.= "expense_accno_id='$dt[expense_accno_id]',inventory_accno_id='$dt[inventory_accno_id]'";
			$adodb->query($sql);
			$sql = "SELECT id,attrib1cap,attrib2cap,attrib3cap,attrib1tbl,attrib2tbl,attrib3tbl," ;
			$sql.= "attrib1sdesc,attrib2sdesc,attrib3sdesc,attrib1ldesc,attrib2ldesc,attrib3ldesc," ;
			$sql.= "attrib1tblmn,attrib2tblmn,attrib3tblmn,attrib1cnval,attrib2cnval,attrib3cnval," ;
			$sql.= "nativecurr,yearend,income_accno_id,expense_accno_id,inventory_accno_id " ;
			$sql.= "FROM $table ";
			$result = $adodb->query($sql);
			$headerarr[$table] = $result->fetchRow();
			$header = addslashes(serialize($headerarr));
			$adodb->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = exapi_lang("Old") ;
			$lang_tran = exapi_lang("Ledger Default Values") ;
			$actioned = exapi_lang("updated") ;
			break ;
		case "defaultsapr" :
			$sql = "UPDATE $table SET " ;
			$sql.= "aptax1cap='$dt[aptax1cap]',aptax2cap='$dt[aptax2cap]'," ;
			$sql.= "aptax1pref='$dt[aptax1pref]',aptax2pref='$dt[aptax2pref]'," ;
			$sql.= "artax1cap='$dt[artax1cap]',artax2cap='$dt[artax2cap]'," ;
			$sql.= "artax1pref='$dt[artax1pref]',artax2pref='$dt[artax2pref]'," ;
			$sql.= "paypalyn='$dt[paypalyn]',paymateyn='$dt[paymateyn]',payasiayn='$dt[payasiayn]'," ;
			$sql.= "paypalemail='$dt[paypalemail]',paymateuname='$dt[paymateuname]'," ;
			$sql.= "inv_rmkid='$dt[inv_rmkid]',rmd_rmkid='$dt[rmd_rmkid]',";
			$sql.= "po_rmkid='$dt[po_rmkid]',quo_rmkid='$dt[quo_rmkid]' ";
			$adodb->query($sql);
			$sql = "SELECT id,aptax1cap,aptax2cap,aptax1pref,aptax2pref," ;
			$sql.= "artax1cap,artax2cap,artax1pref,artax2pref," ;
			$sql.= "paypalyn,paymateyn,payasiayn,paypalemail,paymateuname," ;
			$sql.= "inv_rmkid,rmd_rmkid,po_rmkid,quo_rmkid " ;
			$sql.= "FROM $table ";
			$result = $adodb->query($sql);
			$headerarr[$table] = $result->fetchRow();
			$header = addslashes(serialize($headerarr));
			$adodb->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = exapi_lang("Old") ;
			$lang_tran = exapi_lang("AP/AR/PO/SO/Quotation Default Values") ;
			$actioned = exapi_lang("updated") ;
			break ;
		case "defaultspos" :
			$sql = "UPDATE $table SET " ;
			$sql.= "postax1cap='$dt[postax1cap]',postax2cap='$dt[postax2cap]'," ;
			$sql.= "postax1pref='$dt[postax1pref]',postax2pref='$dt[postax2pref]'," ;
			$sql.= "sm_rmkid='$dt[sm_rmkid]' ";
			$adodb->query($sql);
			$sql = "SELECT id,postax1cap,postax2cap,postax1pref,postax2pref,sm_rmkid FROM $table ";
			$result = $adodb->query($sql);
			$headerarr[$table] = $result->fetchRow();
			$header = addslashes(serialize($headerarr));
			$adodb->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = exapi_lang("Old") ;
			$lang_tran = exapi_lang("Point of Sale Default Values") ;
			$actioned = exapi_lang("updated") ;
			break ;
		case "defaultshrp" :
			$sql = "UPDATE $table SET " ;
			$sql.= "photoyn='$dt[photoyn]',commyn='$dt[commyn]',";
			$sql.= "addressyn='$dt[addressyn]',ecyn='$dt[ecyn]',othersyn='$dt[othersyn]'," ;
			$sql.= "mndfactor='$dt[mndfactor]',smdfactor='$dt[smdfactor]'," ;
			$sql.= "wkdfactor='$dt[wkdfactor]',mnhfactor='$dt[mnhfactor]'," ;
			$sql.= "smhfactor='$dt[smhfactor]',wkhfactor='$dt[wkhfactor]'," ;
			$sql.= "dyhfactor='$dt[dyhfactor]'" ;
			$adodb->query($sql);
			$sql = "SELECT id,photoyn,commyn,addressyn,ecyn,othersyn," ;
			$sql.= "mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor FROM $table ";
			$result = $adodb->query($sql);
			$headerarr[$table] = $result->fetchRow();
			$header = addslashes(serialize($headerarr));
			$adodb->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = exapi_lang("Old") ;
			$lang_tran = exapi_lang("HR/SSS/Payroll Default Values") ;
			$actioned = exapi_lang("updated") ;
			break ;
		case "defaultscss" :
			$sql = "UPDATE $table SET " ;
			$sql.= "centeryn='$dt[centeryn]',contactusyn='$dt[contactusyn]',ledreportyn='$dt[ledreportyn]',";
			$sql.= "custinfoyn='$dt[custinfoyn]',cttinfoyn='$dt[cttinfoyn]',helpcaseyn='$dt[helpcaseyn]'," ;
			$sql.= "contractyn='$dt[contractyn]',quoteyn='$dt[quoteyn]',soyn='$dt[soyn]'," ;
			$sql.= "invoiceyn='$dt[invoiceyn]',ubsoyn='$dt[ubsoyn]',osinvyn='$dt[osinvyn]'," ;
			$sql.= "statementyn='$dt[statementyn]'" ;
			$adodb->query($sql);
			$sql = "SELECT id,centeryn,contactusyn,ledreportyn,custinfoyn,cttinfoyn,helpcaseyn," ;
			$sql.= "contractyn,quoteyn,soyn,invoiceyn,ubsoyn,osinvyn,statementyn FROM $table ";
			$result = $adodb->query($sql);
			$headerarr[$table] = $result->fetchRow();
			$header = addslashes(serialize($headerarr));
			$adodb->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = exapi_lang("Old") ;
			$lang_tran = exapi_lang("Customer Self Service Default Values") ;
			$actioned = exapi_lang("updated") ;
			break ;
		endswitch ;

	$adodb->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='defaultsedit'");

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$adodb->query($sql);
	
	$message = "$type $lang_tran [id#$id] $actioned" ; 
	$t->set_var("message","<b>$message.  $reminder.</b>");
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	}
	
//---- Set Up Table Select Option List

    function table_selectlist($filter,$default) {
	global $ckapi,$pre,$adodb ;

	$sql = "select relname from pg_class where relkind='r' " ;
	$sql.= "and relname!~'^pg_' and relname!~'^pga_' and relname !~'^pgadmin_'" ;
	if ($ckapi[hostsys][dbtype] == "mysql")	$sql = "show tables" ;
	$result = $adodb->query($sql);
	$selectlist="";
	While ($rs=$result->fetchRow()) {
		$table = $rs[0] ;
		$selectlist .= "<OPTION value='$table'>$table</OPTION>" ;
		}
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

    }

?>
