<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.leaveapp.inc.php 0.13.1 2005/06/15 C K Wu

    class leaveapp {

//---- Leave Application List SQL Formation

    function leaveapp_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$app = $ckapi[params][app] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$lang_leave = strtolower(exapi_lang('leave')) ;
	if (!$order)	$order = "staff,leavefrom,leaveto" ;
	if (!$sort)	$sort = "ASC" ;
	$sql =  "SELECT b.name as staff,a.*,description " ;
	$sql.=  "FROM ${pre}leaveapp a, ${pre}employee b, ${pre}category c ";
	$sql.=  "WHERE empid=b.id and leavecode=c.name and app='$app' and c.type='$lang_leave' $where " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- Leave Application Read

    function leaveapp_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT * from $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	if ($ckapi[params_post][op]<>'view')	$dt[approved_by] = exapi_lang("HR staff") ;
	if (!is_array($uniqueflds) or $op<>'edit')    return $dt;
	  else  {foreach ($uniqueflds as $key => $val)	$dt["old$val"]=$dt["$val"];	return $dt ;}
	}

//---- Leave Application Detail Validation Checks

    function leaveapp_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error = exapi_lang("Error") ;
	$leavefrom = $dt[leavefrom] ;
	$leaveto = $dt[leaveto] ;
	if (input2date($leavefrom)=="")		$err=exapi_lang("Invalid From Date");
	if (input2date($leaveto)=="")		$err=exapi_lang("Invalid To Date");
	$from = strtotime($leavefrom) ;
	$to = strtotime($leaveto) ;
	if ($from<mktime(0,0,0))		$err=exapi_lang("Leave application cannot be retrospective") ;
	if ($leavefrom<>"" and $leaveto<>"" and $from>$to)	$err=exapi_lang("From Date later than To Date") ;
	$duration = $dt[duration] ;
	if (!is_numeric($duration) or $duration=='' or $duration==0)
						$err=exapi_lang("invalid Workdays figure") ;
	if ($duration*10%5 <>0)			$err=exapi_lang("Workdays must be whole day or half a day") ;
	if ($leavefrom<>"" and $leaveto<>"" and ($to-$from)<(($duration-1)*24*60*60))
						$err=exapi_lang("Work Days > Leave Period duration") ;
	if (substr($leavefrom,0,4)<>substr($leaveto,0,4))
						$err=exapi_lang("Leave From year must equal Leave To year") ;
	$dt[id] = ($dt[id]=="") ? 0 : $dt[id] ;
	$sql =	"SELECT * FROM ${pre}leaveapp WHERE ((leavefrom>='$leavefrom' and leavefrom<='$leaveto') " ;
	$sql.=	"or (leaveto>='$leavefrom' and leaveto<='$leaveto')) and empid=$dt[empid] and id<>'$dt[id]'" ;
	$result = $adodb->query($sql);
	if ($result->RecordCount()>0)		$err=exapi_lang("This application overlaps with existing leave applications");
	$sql =	"SELECT * FROM ${pre}leaveapp WHERE (('$leavefrom'>=leavefrom and '$leavefrom'<=leaveto) " ;
	$sql.=	"or ('$leaveto'>=leavefrom and '$leaveto'<=leaveto)) and empid=$dt[empid] and id<>'$dt[id]'" ;
	$result = $adodb->query($sql);
	if ($result->RecordCount()>0)		$err=exapi_lang("This application overlaps with existing leave applications") ;

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Leave Application Add Initialisation

    function leaveapp_add_init() {
	global $ckapi ;

	$ckapi[params_post][dt][approved_by] = exapi_lang("HR staff") ;
	}

//---- Leave Application Post - PostCommit Routine

    function leaveapp_post_postcommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;

	$user = $ckapi[hostsys][username];
	$sql = "SELECT a.*,prsnumber as name FROM ${pre}comm a, ${pre}empperson b " ;
	$sql.= "WHERE contactid=b.id and username='$user' and commcode='wemail'" ;
	$result = $adodb->query($sql);
	$hrstaffname = $result->fields('name');
	$hrstaffemail = $result->fields('commdata') ;
	$sql = "SELECT a.*,prsnumber as name FROM ${pre}comm a, ${pre}empperson b, ${pre}employee c " ;
	$sql.= "WHERE a.contactid=b.id and c.contactid=b.id and c.id='$dt[empid]' and commcode='wemail'" ;
	$result = $adodb->query($sql);
	$staffname = $result->fields('name');
	$staffemail = $result->fields('commdata') ;
	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE id='$dt[empid]'");
	$superid = $result->fields('supervisor');
	$sql = "SELECT a.*,prsnumber as name FROM ${pre}comm a, ${pre}empperson b, ${pre}employee c " ;
	$sql.= "WHERE a.contactid=b.id and c.contactid=b.id and c.id='$superid' and commcode='wemail'" ;
	$result = $adodb->query($sql);
	$supername = $result->fields('name');
	$superemail = $result->fields('commdata') ;
	$recipient = "$staffname < $staffemail >" ;

	$subject = exapi_lang("%1's Leave Application [From:%2 To:%3] %4 by HR Staff", $staffname,$dt[leavefrom],$dt[leaveto],$ckapi[phrases][actioned]) ;
	$message = '' ;
	$headers = "From: $hrstaffname < $hrstaffemail > \n" ;
	$charset = exapi_lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $hrstaffname < $hrstaffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = exapi_lang("Email advising action on %1's Leave Application [From:%2 To:%3] successfully queued for despatch to",$staffname,$dt[leavefrom],$dt[leaveto]) ;
	$failuremsg = exapi_lang("Email advising action on %1's Leave Application [From:%2 To:%3] fails to deliver.  Please manually inform",$staffname,$dt[leavefrom],$dt[leaveto]) ;
	$lang_staff = exapi_lang("Staff:") ;
	if ($result)	$msg = "$msg<br>$lang_staff $successmsg $staffname." ;
		else	$msg = "$msg<br>$lang_staff $failuremsg $staffname." ;
	$recipient = "$supername < $superemail >" ;
	$lang_super = exapi_lang("Supervisor:") ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($result)	$msg = "$msg<br>$lang_super $successmsg $supername." ;
		else	$msg = "$msg<br>$lang_super $failuremsg $supername." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

//---- Write Leave Application Detail

    function leaveapp_write() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',exapi_lang('Employee Name/#'));
	$t->set_var('lang_id',exapi_lang('ID#'));
	$t->set_var('lang_leavefrom',exapi_lang('Leave From'));
	$t->set_var('lang_leaveto',exapi_lang('Leave To'));
	$t->set_var('lang_duration',exapi_lang('Duration in Workdays'));
	$t->set_var('lang_leavecode',exapi_lang('Leave Code -- Description'));
	$t->set_var('lang_approved_by',exapi_lang('Approved By'));
	$user = $ckapi[hostsys][username];
	$where = (!$uniwhere) ? " WHERE id='$dt[empid]' " : $uniwhere;
	$t->set_var('empid_selectlist',selectlist('employee','name',$where,$dt[empid],'id','name','id')) ;
	$t->set_var('staff',$dt[staff]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('leavefrom',$dt[leavefrom]);
	$t->set_var('leaveto',$dt[leaveto]);
	$t->set_var('duration',$dt[duration]);
	$lang_leave = strtolower(exapi_lang('leave')) ;
	$where = "WHERE app='$app' and type='$lang_leave' and name<>'SL' and name<>'UA'" ;
	$leavecode_sl = selectlist('category','name',$where,$dt[leavecode],'name','name','substring(description,1,25)') ;
	$t->set_var('leavecode_selectlist',$leavecode_sl);
	$t->set_var('approved_by',$dt[approved_by]);
	$t->parse('out','report',True);
	}

    }

?>
