<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.inventory.inc.php 0.13.1 2005/06/15 C K Wu

	class inventory {  

//---- Inventory Read

    function inventory_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$uniqueflds = $ckapi[params][uniqueflds] ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$result = $adodb->query("select * from ${pre}parts where id='$id'");
	$dt = $result->fetchRow() ;
	$dt[oldprice] = $result->fields('price') ;
	$dt[oldcost] = $result->fields('cost') ;
	$sql = "select tax_id from ${pre}itemtax a,${pre}tax b where item_id = '$id'" ;
	$result = $adodb->query("$sql and taxtype=1 and a.tax_id=b.id and b.taxgroup='ap'");
	$dt[aptax1] = $result->fields('tax_id') ;
	$result = $adodb->query("$sql and taxtype=2 and a.tax_id=b.id and b.taxgroup='ap'");
	$dt[aptax2] = $result->fields('tax_id') ;
	$result = $adodb->query("$sql and taxtype=1 and a.tax_id=b.id and b.taxgroup='ar'");
	$dt[artax1] = $result->fields('tax_id') ;
	$result = $adodb->query("$sql and taxtype=2 and a.tax_id=b.id and b.taxgroup='ar'");
	$dt[artax2] = $result->fields('tax_id') ;
	$result = $adodb->query("$sql and taxtype=1 and a.tax_id=b.id and b.taxgroup='cs'");
	$dt[cstax1] = $result->fields('tax_id') ;
	$result = $adodb->query("$sql and taxtype=2 and a.tax_id=b.id and b.taxgroup='cs'");
	$dt[cstax2] = $result->fields('tax_id') ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}
	
//---- Inventory Addition Initiation

    function inventory_add_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$result = $adodb->query("select * from ${pre}defaults");
	$ckapi[params_post][dt][inventory_accno_id] =  $result->fields('inventory_accno_id') ;
	$ckapi[params_post][dt][income_accno_id] =  $result->fields('income_accno_id') ;
	$ckapi[params_post][dt][expense_accno_id] =  $result->fields('expense_accno_id') ;
	}

//---- Inventory Detail Validation Checks

    function inventory_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	if ($dt[partnumber]=="")			$err=exapi_lang("Part Name/Number Missing");
	if ($dt[rop] and !is_numeric($dt[rop]))		$err=exapi_lang("Invalid Reorder Level, must be numeric");
	if (strlen($dt[unit])>5)			$err=exapi_lang("Unit description too long, must be <= 5");
	if ($dt[weight] and !is_numeric($dt[weight]))	$err=exapi_lang("Invalid Weight, must be numeric");
	if ($dt[listprice] and !is_numeric($dt[listprice]))
							$err=exapi_lang("Invalid list price, must be numeric");
	if ($dt[price] and !is_numeric($dt[price]))
							$err=exapi_lang("Invalid selling price, must be numeric");
	if ($dt[cost] and !is_numeric($dt[cost]))	$err=exapi_lang("Invalid Cost, must be numeric");
	if ($dt[listprice] and $dt[price] and ($dt[listprice]<$dt[price]))
							$err=exapi_lang("List Price < Selling Price");
	if ($dt[partnumber]<>$dt[oldpartnumber]) {
		$result = $adodb->query("SELECT * FROM ${pre}parts where partnumber='$dt[partnumber]'");
		if ($result->RecordCount()>0)		$err=exapi_lang("Inventory Item Name/# already exists") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Inventory Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$invtran = exapi_lang('inventory transaction') ;
	$invoice = exapi_lang('invoice') ; $order = exapi_lang('order');
	$quote = exapi_lang('quotation'); $cashsale = exapi_lang('cash sale') ;
	$errmsg1 = exapi_lang("This inventory part is in use within an existing") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * from ${pre}inv_trans WHERE parts_id='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $invtran id#".$result->fields('trans_id') ;
	$result = $adodb->query("SELECT * from ${pre}invoice WHERE itemid='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $invoice id#".$result->fields('trans_id') ;
	$result = $adodb->query("SELECT * from ${pre}oitem WHERE itemid='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $order/$quote id#".$result->fields('trans_id') ;
	$result = $adodb->query("SELECT * from ${pre}positem WHERE itemid='$id'");
	if ($result->RecordCount()>0)	$err = "$errmsg1 $cashsale id#".$result->fields('trans_id') ;

	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Inventory Detail

    function inventory_write() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_tbi',exapi_lang("(To be implemented)"));
	$t->set_var('lang_ginfo',exapi_lang("General Information"));
	$t->set_var('lang_number',exapi_lang("Name/Number"));
	$t->set_var('lang_description',exapi_lang("Description"));
	$t->set_var('lang_id',exapi_lang("Audit Id :"));
	$t->set_var('lang_photo',exapi_lang("Photo :"));
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('lang_quantity',exapi_lang("Quantity"));
	$t->set_var('lang_bin',exapi_lang("Bin Location"));
	$t->set_var('lang_rop',exapi_lang("Reorder Level (info only)"));
	$t->set_var('lang_unit',exapi_lang("Unit"));
	$t->set_var('lang_weight',exapi_lang("Weight"));
	$t->set_var('lang_pricecost',exapi_lang("Price/Cost"));
	$t->set_var('lang_listprice',exapi_lang("List Price"));
	$t->set_var('lang_price',exapi_lang("Selling Price"));
	$t->set_var('lang_priceupdate',exapi_lang("Price Last Updated on"));
	$t->set_var('lang_cost',exapi_lang("Standard Cost"));
	$t->set_var('lang_costupdate',exapi_lang("Cost Last Updated on"));
	$t->set_var('lang_notes',exapi_lang("Notes"));
	$t->set_var('lang_linkageaccount',exapi_lang("Link to Ledger Accounts"));
	$t->set_var('lang_inventory_accno',exapi_lang("Inventory Account"));
	$t->set_var('lang_income_accno',exapi_lang("Sales Account"));
	$t->set_var('lang_expense_accno',exapi_lang("COGS Account"));
	$t->set_var('lang_tax',exapi_lang("Tax"));
	$t->set_var('lang_aptax1',exapi_lang("Primary Tax Paid to Vendor"));
	$t->set_var('lang_aptax2',exapi_lang("Secondary Tax Paid to Vendor"));
	$t->set_var('lang_artax1',exapi_lang("Primary Tax from Customer"));
	$t->set_var('lang_artax2',exapi_lang("Secondary Tax from Customer"));
	$t->set_var('lang_cstax1',exapi_lang("Primary Tax for Cash Sale"));
	$t->set_var('lang_cstax2',exapi_lang("Secondary Tax for Cash Sale"));
	$t->set_var('lang_reserved',exapi_lang('Reserved Space'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('partnumber',$dt[partnumber]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('description',$dt[description]);
	$t->set_var('bin',$dt[bin]);
	$t->set_var('notes',$dt[notes]);
	$t->set_var('rop',$dt[rop]);
	$t->set_var('unit',$dt[unit]);
	$t->set_var('weight',$dt[weight]);
	$t->set_var('listprice',$dt[listprice]);
	$t->set_var('price',$dt[price]);
	$t->set_var('oldprice',$dt[oldprice]);
	$t->set_var('priceupdate',$dt[priceupdate]);
	$t->set_var('cost',$dt[cost]);
	$t->set_var('oldcost',$dt[oldcost]);
	$t->set_var('costupdate',$dt[costupdate]);
	$inv_acc = $dt[inventory_accno_id] ;
	$t->set_var('inventory_accno',$inv_acc);
	$t->set_var('invacc_sl',selectlist('chart','accno',"WHERE link like '%IC:%' or link like '%IC'",$inv_acc,'id','accno','description'));
	$inc_acc = $dt[income_accno_id] ;
	$t->set_var('income_accno',$inc_acc);
	$t->set_var('incacc_sl', selectlist('chart','accno',"WHERE link like '%IC_sale%'",$inc_acc,'id','accno','description'));
	$exp_acc = $dt[expense_accno_id] ;
	$t->set_var('expense_accno',$exp_acc);
	$t->set_var('expacc_sl',selectlist('chart','accno',"WHERE link like '%IC_cogs%'",$exp_acc,'id','accno','description'));
	$notax = "<OPTION value=''>".exapi_lang('No Tax')."</OPTION>" ;
	$rate = ($ckapi[hostsys][dbtype]=="mysql") ? "concat(rate*100,'%')" : "(rate*100||'%')" ;
	$t->set_var('aptax1_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ap'",$dt[aptax1],'id',$rate,'taxnumber','id'));
	$t->set_var('aptax2_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ap'",$dt[aptax2],'id',$rate,'taxnumber','id'));
	$t->set_var('artax1_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ar'",$dt[artax1],'id',$rate,'taxnumber','id'));
	$t->set_var('artax2_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ar'",$dt[artax2],'id',$rate,'taxnumber','id'));
	$t->set_var('cstax1_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='cs'",$dt[cstax1],'id',$rate,'taxnumber','id'));
	$t->set_var('cstax2_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='cs'",$dt[cstax2],'id',$rate,'taxnumber','id'));

	$img = $ckapi[hostsys][dataarea]."/images/$dt[id].png" ;
	$t->set_var('image',exapi_link("/ck-inv/inventoryview_image.php","imgfile=$img"));

	$t->parse('out','report',True);
	}

//---- Inventory Post Initialisation

    function inventory_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$op = &$ckapi[params_post][op] ;

	$dt[priceupdate] = ($dt[oldprice]<>$dt[price] or $op=='new') ? date("Y-m-d") : $dt[priceupdate] ;
	$dt[costupdate] = ($dt[oldcost]<>$dt[cost] or $op=='new') ? date("Y-m-d") : $dt[costupdate] ;
	}

//---- Inventory Post - PreCommit Routine

    function inventory_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	if ($op<>'new')		$adodb->query("DELETE FROM ${pre}itemtax WHERE item_id=$id") ;
	if ($op<>'delete') {
		$sql="INSERT INTO ${pre}itemtax (item_id,tax_id,taxtype) " ;
		if ($dt[aptax1]<>"")	$adodb->query("$sql VALUES ('$id','$dt[aptax1]','1')");
		if ($dt[aptax2]<>"")	$adodb->query("$sql VALUES ('$id','$dt[aptax2]','2')");
		if ($dt[artax1]<>"")	$adodb->query("$sql VALUES ('$id','$dt[artax1]','1')");
		if ($dt[artax2]<>"")	$adodb->query("$sql VALUES ('$id','$dt[artax2]','2')");
		if ($dt[cstax1]<>"")	$adodb->query("$sql VALUES ('$id','$dt[cstax1]','1')");
		if ($dt[cstax2]<>"")	$adodb->query("$sql VALUES ('$id','$dt[cstax2]','2')");
		}
	}

    }

?>