<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.nrtrans.inc.php 0.13.1 2005/06/15 C K Wu
    
    class nrtrans {

//---- Non-recurring Payroll Item List SQL Formation

    function nrtrans_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$sortkey = $ckapi[params][sortkey] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if (!$order)	{if ($sortkey<>"")	$order=$sortkey;	else $order=$field1;}
	if (!$sort)	$sort = "ASC" ;
	$sql =	"SELECT b.name as empname,c.name as pyrname,description," ;
	$sql.=	"a.qty,a.unit,a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}employee b, ${pre}pyrcode c " ;
	$sql.=	"WHERE empid=b.id and pyrcodeid=c.id $where order by $order $sort" ;

	return $sql ;
	}

//---- Non-recurring Payroll Item Read

    function nrtrans_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$sql =	"SELECT a.empid,salary,period,pyrcodeid as eaid,basis,a.qty,a.unit," ;
	$sql.=	"a.unitamt,a.rate,a.amount,comment,approved_by,a.chart_id,a.id,a.control " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}payroll b, ${pre}pyrcode c " ;
	$sql.=	"WHERE a.id='$id' and a.empid=b.empid and pyrcodeid=c.id" ;
	$result = $adodb->query($sql);
	$dt = $result->fetchRow() ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$result = $adodb->query($sql);
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$result->fields('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$result->fields('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$result->fields('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$result->fields('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $result->fields('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	if ($op=='add' or $op=='copy') {
		$dt[id] = "" ;
		$dt[approved_by] = exapi_lang("payroll staff") ;
		}
	if (is_array($uniqueflds) and $op=='edit')
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Non-recurring Payroll Item Add Initialisation

    function nrtrans_add_init() {
	global $ckapi,$adodb ;

	foreach ($ckapi[buttons] as $key => $val)	$$key = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

//	if ($dt[empid]=="" and $dt[lastempid]=="")		return ;	// may have to uncomment this one
	$dt[empid] = ($dt[empid]=="") ? 0 : $dt[empid] ;
	$result = $adodb->query("SELECT * from ${pre}payroll WHERE empid='$dt[empid]'");
	if ($result->RecordCount()==0 and (isset($post) or isset($refresh))) {
		$error = exapi_lang("Error") ;
		$err = exapi_lang("Employee Payroll Master Info missing") ;
		$t->set_var('message',"<b>$error:  $err</b>");
		$ckapi[params][nomaster] = True ;
		}
	$dt[salary] = $result->fields('salary') ;
	$dt[period] = $result->fields('period') ;
	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$result = $adodb->query($sql);
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$result->fields('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$result->fields('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$result->fields('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$result->fields('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$result->fields('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $result->fields('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	$dt[id] = "" ;
	$dt[approved_by] = exapi_lang("payroll staff") ;
	}

//---- Non-recurring Payroll Item Validation Checks

    function nrtrans_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error = exapi_lang("Error") ;
	$eaid = $dt[eaid] ;
	$qty = $dt[qty] ;
	$amt = $dt[amount] ;
	$dt[empid] = ($dt[empid]=="") ? 0 : $dt[empid] ;
	$result = $adodb->query("SELECT * from ${pre}payroll WHERE empid='$dt[empid]'");
	if ($result->RecordCount()==0)		$err=exapi_lang("Employee Payroll Master Info missing") ;
	$result = $adodb->query("SELECT * from ${pre}pyrcode where id='$eaid'");
	if ($qty<$result->fields('minqty'))	$err=exapi_lang("Quantity too low");
	if ($qty>$result->fields('maxqty'))	$err=exapi_lang("Quantity too high");
	if ($amt<$result->fields('minamt'))	$err=exapi_lang("Amount too low");
	if ($amt>$result->fields('maxamt'))	$err=exapi_lang("Amount too high");
	if ($qty=="")				$err=exapi_lang("Quantity Missing");
	if ($qty<>"" and !is_numeric($qty))	$err=exapi_lang("Quantity must be numeric");
	if ($amt=="")				$err=exapi_lang("Amount Missing");
	if ($amt<>"" and !is_numeric($amt))	$err=exapi_lang("Amount must be numeric");
	if ($result->fields('single')=="y" and $dt[eaid]<>$dt[oldeaid]) {
		$sql = "SELECT * from ${pre}pyrc_trans a, ${pre}payroll b " ;
		$sql.= "WHERE a.pyroid=b.id and b.empid='$dt[empid]' and pyrcodeid='$eaid'" ;
		$result = $adodb->query($sql);
		if ($result->RecordCount()>0)  $err=exapi_lang("This Expense/Allowance (recurring) already exists");
		if ($eaid<>$oldeaid) {
			$sql = "SELECT * from ${pre}pynr_trans " ;
			$sql.= "WHERE empid='$dt[empid]' and pyrcodeid='$eaid'" ;
			$result = $adodb->query($sql);
			if ($result->RecordCount()>0)
				$err=exapi_lang("This Expense/Allowance (non-recurring) already exists") ;
			}
		}
	if ($dt[empid]<>$dt[lastempid] or $dt[eaid]<>$dt[lasteaid]) {
		$warn1 = exapi_lang("(Employee Name/#) or (Expense/Allowance Type) had just been updated.") ;
		$warn2 = exapi_lang("Ensure other data are appropriately adjusted and updated.") ;
		$warn3 = exapi_lang("Then re-click [Post ...] button")  ;
		$err = "$warn1<br>$warn2  $warn3" ;
		}
	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Non-recurring Payroll Item Detail

    function nrtrans_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	if ($dt[empid]<>$dt[lastempid] and $dt[lastempid]<>"")		$this->nrtrans_add_init() ;
	$t->set_var('lang_empid',exapi_lang('Employee Name/#'));
	$t->set_var('lang_id',exapi_lang('ID#'));
	$t->set_var('lang_salary',exapi_lang('Basic Salary'));
	$t->set_var('lang_period',exapi_lang('Pay Period'));
	$t->set_var('lang_daypay',exapi_lang('Imputed Daily Pay'));
	$t->set_var('lang_hourpay',exapi_lang('Imputed Hourly Pay'));
	$t->set_var('lang_eaid',exapi_lang('Expense/Allowance Type'));
	$t->set_var('lang_basis',exapi_lang('Basis of Calculation'));
	$t->set_var('lang_qty',exapi_lang('Quantity'));
	$t->set_var('lang_unit',exapi_lang('Unit'));
	$t->set_var('lang_unitamt',exapi_lang('Unit Amount'));
	$t->set_var('lang_rate',exapi_lang('Pay Rate'));
	$t->set_var('lang_amount',exapi_lang('Amount'));
	$t->set_var('lang_comment',exapi_lang('Comment'));
	$t->set_var('lang_approved_by',exapi_lang('Approved By'));
	$t->set_var('lang_chart_id',exapi_lang('Payroll Expense Account'));
	$where = (!$uniwhere) ? " WHERE id='$dt[empid]' " : $uniwhere;
	$t->set_var('empid_selectlist',selectlist('employee','name',$where,$dt[empid],'id','name','id')) ;
	$t->set_var('lastempid',$dt[empid]) ;
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('salary',$dt[salary]);
	$t->set_var('period',$dt[period]) ;
	$t->set_var('daypay',$dt[daypay]);
	$t->set_var('hourpay',$dt[hourpay]) ;
	$eaid = $dt[eaid] ;
	$t->set_var('eaid_selectlist',selectlist('pyrcode','name','',$eaid,'id','description','id')) ;
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var("lasteaid",$eaid);

	$qty = 1 ;
	$eaid = ($eaid=="") ? 0 : $eaid ;
	$result = $adodb->query("SELECT * from ${pre}pyrcode where id='$eaid'");
	$basis		=	$result->fields('basis') ;
	$unit		=	$result->fields('unit') ;
	$unitamt	=	(substr_count($basis,'pc')>0) ? $result->fields('unitamt') : 1 ;
	$rate		=	$result->fields('rate') ;
	$chart_id	=	($dt[rate]==0) ? $result->fields('chart_id') : $dt[chart_id] ;
	$dt[chart_id]	=	$result->fields('chart_id') ;
	if (substr_count($basis,'qty')>0)	{$qty = $dt[qty]; $t->set_var('qty_readonly','');}
		else				$t->set_var('qty_readonly','readonly') ;
	if (substr_count($basis,'bs')>0)	$unitamt = $dt[salary] ;
	if (substr_count($basis,'hp')>0)	$unitamt = $dt[hourpay] ;
	if (substr_count($basis,'dp')>0)	$unitamt = $dt[daypay] ;
	$amount = sprintf("%01.2f",$qty*$unitamt*$rate) ;
	if (substr_count($basis,'amt')>0)	{$amount=$dt[amount]; $t->set_var('amt_readonly','');}
		else				$t->set_var('amt_readonly','readonly') ;
	$dt[qty] = $qty ;
	$dt[unit] = $unit ;
	$dt[unitamt] = $unitamt ;
	$dt[rate] = $rate ;
	$dt[amount] = $amount ;
	$dt[chart_id] = $chart_id ;
	$t->set_var('basis',$basis);
	$t->set_var('qty',$qty);
	$t->set_var('unit',$unit);
	$t->set_var('unitamt',$unitamt);
	$t->set_var('rate',$rate);
	$t->set_var('amount',$amount);
	$t->set_var('comment',$dt[comment]);
	$t->set_var('approved_by',$dt[approved_by]);
	$chartid_sl = selectlist('chart','accno',"WHERE link like '%PY_expense%'",$chart_id,'id','accno','description') ;
	$t->set_var('chart_id_selectlist',$chartid_sl);
	if ((($dt[empid]<>$dt[lastempid] and $dt[lastempid]<>"") or ($dt[eaid]<>$dt[lasteaid] and $dt[lasteaid]<>"")) and !$ckapi[params][nomaster]) {
		$warning = exapi_lang("Warning") ;
		$warn1 = exapi_lang("(Employee Name/#) or (Expense/Allowance Type) had just been updated.") ;
		$warn2 = exapi_lang("Ensure other data are appropriately adjusted and updated.") ;
		$t->set_var('message',"<b>$warning:  $warn1<br>$warn2</b>");
		}
	$t->parse('out','report',True);
	}

//---- Non-recurring Payroll Item Post Initialisation

    function nrtrans_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][pyrcodeid] = $ckapi[params_post][dt][eaid] ;
	}

//---- Non-recurring Payroll Item Post - PostCommit Routine

    function nrtrans_post_postcommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$actioned = $ckapi[phrases][actioned] ;

	$user = $ckapi[hostsys][username];
	$result = $adodb->query("SELECT name,a.id,contactid FROM ${pre}employee a,${pre}empperson b WHERE contactid=b.id and username='$user'");
	$pystaffname = $result->fields('name');
	$pystaffid = $result->fields('id');
	$pystaffcontactid = $result->fields('contactid');
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$pystaffcontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$pystaffemail = $result->fields('commdata') ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername,a.contactid as staffcontactid,b.contactid as supercontactid ";
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$result = $adodb->query($sql);
	$staffname = $result->fields('staffname');
	$superid = $result->fields('superid');
	$supername = $result->fields('supername');
	$staffcontactid = $result->fields('staffcontactid');
	$supercontactid = $result->fields('supercontactid');
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$staffcontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$staffemail = $result->fields('commdata') ;
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$supercontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$superemail = $result->fields('commdata') ;
	$recipient = "$staffname < $staffemail >" ;
	$subject = exapi_lang("%1's Non-recurring Payroll Item [id#%2] %3 by Payroll Staff",$staffname,$id,$actioned) ;
	$message = '' ;
	$headers = "From: $pystaffname < $pystaffemail > \n" ;
	$charset = exapi_lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $pystaffname < $pystaffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = exapi_lang("Email advising action on non-recurring payroll item [id#%1] successfully queued for despatch to",$id) ;
	$failuremsg = exapi_lang("Email advising action on non-recurring payroll item [id#%1] fails to deliver.  Please manually inform",$id) ;
	$lang_staff = exapi_lang("Staff:") ;
	if ($result)	$msg = "$msg<br>$lang_staff $successmsg $staffname." ;
		else	$msg = "$msg<br>$lang_staff $failuremsg $staffname." ;
	$recipient = "$supername < $superemail >" ;
	$lang_super = exapi_lang("Supervisor:") ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($result)	$msg = "$msg<br>$lang_super $successmsg $supername." ;
		else	$msg = "$msg<br>$lang_super $failuremsg $supername." ;
	$ckapi[phrases]["reminder"] = $msg ;

	}

    }

?>
